package net.minecraft.src;

import java.util.Map.Entry;

public class LMM_Net {
	
	/*
	 * p萔A8bitڂ𗧂ĂEntityv
	 */
	public static final byte LMN_Server_UpdateSlots		= (byte)0x80;
	public static final byte LMN_Server_SetTexture		= (byte)0x81;
	public static final byte LMN_Client_SwingArm		= (byte)0x81;
	public static final byte LMN_Client_UpdateTexture	= (byte)0x83;
	public static final byte LMN_Server_SetIFFValue		= (byte)0x04;
	public static final byte LMN_Client_SetIFFValue		= (byte)0x04;
	public static final byte LMN_Server_SaveIFF			= (byte)0x05;
	public static final byte LMN_Server_GetIFFValue		= (byte)0x06;
//	public static final byte LMN_Server_GetTextureIndex	= (byte)0x07;
//	public static final byte LMN_Client_SetTextureIndex	= (byte)0x87;
//	public static final byte LMN_Server_GetTextureStr	= (byte)0x08;
//	public static final byte LMN_Client_SetTextureStr	= (byte)0x08;
	


	
	
	/*
	 * LMMPacet̃tH[}bg
	 * (Byte)
	 * 0	: (1byte)
	 * 1 - 4: EntityID(4Byte)ꍇɊĂ͏ȗ 
	 * 5 - 	: Data
	 * 
	 */
			
	
	
	
	/**
	 * nꂽf[^̐擪ɎEntityIDt^đSẴNCAg֑M
	 */
	public static void sendToAllEClient(LMM_EntityLittleMaid pEntity, byte[] pData) {
		MMM_Helper.setInt(pData, 1, pEntity.entityId);
		((WorldServer)pEntity.worldObj).getEntityTracker().sendPacketToAllPlayersTrackingEntity(pEntity, new Packet250CustomPayload("LMM|Upd", pData));
	}

	/**
	 * nꂽf[^̐擪ɎEntityIDt^ē̂̃NCAg֑M
	 */
	public static void sendToEClient(NetServerHandler pHandler, LMM_EntityLittleMaid pEntity, byte[] pData) {
		MMM_Helper.setInt(pData, 1, pEntity.entityId);
		ModLoader.serverSendPacket(pHandler, new Packet250CustomPayload("LMM|Upd", pData));
	}

	public static void sendToClient(NetServerHandler pHandler, byte[] pData) {
		ModLoader.serverSendPacket(pHandler, new Packet250CustomPayload("LMM|Upd", pData));
	}

	/**
	 * nꂽf[^̐擪EntityIDt^ăT[o[֑MB
	 * 0:Mode, 1-4:EntityID, 5-:Data
	 */
	public static void sendToEServer(LMM_EntityLittleMaid pEntity, byte[] pData) {
		MMM_Helper.setInt(pData, 1, pEntity.entityId);
		ModLoader.clientSendPacket(new Packet250CustomPayload("LMM|Upd", pData));
		mod_LMM_littleMaidMob.Debug(String.format("LMM|Upd:send:%2x:%d", pData[0], pEntity.entityId));
	}

	public static void sendToServer(byte[] pData) {
		ModLoader.clientSendPacket(new Packet250CustomPayload("LMM|Upd", pData));
		mod_LMM_littleMaidMob.Debug(String.format("LMM|Upd:%2x:NOEntity", pData[0]));
	}

	/**
	 * T[o[IFF̃Z[uNGXg
	 */
	public static void saveIFF() {
		sendToServer(new byte[] {LMN_Server_SaveIFF});
	}
	
	/**
	 * littleMaidEntityԂB
	 */
	public static LMM_EntityLittleMaid getLittleMaid(byte[] pData, int pIndex, World pWorld) {
		Entity lentity = MMM_Helper.getEntity(pData, pIndex, pWorld);
		if (lentity instanceof LMM_EntityLittleMaid) {
			return (LMM_EntityLittleMaid)lentity;
		} else {
			return null;
		}
	}

	// MpPbg̏
	
	public static void serverCustomPayload(NetServerHandler var1, Packet250CustomPayload var2) {
		// T[o̓
		byte lmode = var2.data[0];
		int leid = 0;
		LMM_EntityLittleMaid lemaid = null;
		if ((lmode & 0x80) != 0) {
			leid = MMM_Helper.getInt(var2.data, 1);
			lemaid = getLittleMaid(var2.data, 1, var1.playerEntity.worldObj);
			if (lemaid == null) return;
		}
		mod_LMM_littleMaidMob.Debug(String.format("LMM|Upd Srv Call[%2x:%d].", lmode, leid));
		byte[] ldata;
		
		switch (lmode) {
		case LMN_Server_UpdateSlots : 
			// XVƂ
			// Cxg̍XV
			lemaid.maidInventory.clearChanged();
			for (LMM_SwingStatus lswing : lemaid.mstatSwingStatus) {
				lswing.lastIndex = -1;
			}
			break;
			
		case LMN_Server_SetTexture:
			// eNX`ԍNCAg󂯎
			int lindex = MMM_Helper.getShort(var2.data, 5);
			int larmor = MMM_Helper.getShort(var2.data, 7);
			lemaid.setTextureIndex(lindex, larmor);
			break;
			
		case LMN_Server_SetIFFValue:
			// IFF̐ݒlM
			int lval = var2.data[1];
			String lname = "";
			for (int li = 6; li < var2.data.length; li++) {
				lname += (char)var2.data[li];
			}
			LMM_IFF.setIFFValue(var1.playerEntity.username, lname, lval);
			break;
		case LMN_Server_SaveIFF:
			// IFFt@C̕ۑ
			LMM_IFF.saveIFF(var1.playerEntity.username);
			break;
		case LMN_Server_GetIFFValue:
			// IFFGUI open
			for (Entry<String, Integer> le : LMM_IFF.DefaultIFF.entrySet()) {
				ldata = new byte[le.getKey().length() + 2];
				ldata[0] = LMN_Client_SetIFFValue;
				ldata[1] = (byte)le.getValue().intValue();
				LMM_Net.sendToClient(var1, ldata);
			}
			break;
			
		}
	}

	
}
